#include <vcl.h>
#pragma hdrstop

#include "djPageControl.h"
#pragma package(smart_init)


__fastcall TdjPageControl::TdjPageControl(
   TComponent* Owner) : TPageControl(Owner)
   {
   lookAndFeel = fpcFlat;
   }

void __fastcall TdjPageControl::WndProc(Messages::TMessage &Message)
   {
   TPageControl::WndProc(Message);

   if (lookAndFeel == fpcNormal) return;

   if (Message.Msg == WM_PAINT && Style == tsTabs)
      {
      TCanvas *canvas = new TCanvas;

      try
         {
         HWND h = Handle;
         canvas->Handle = GetDeviceContext(h);

         canvas->Pen->Style = psSolid;
         canvas->Pen->Mode = pmCopy;

         canvas->Pen->Width = 1;
         canvas->Pen->Color = clBtnHighlight;
         canvas->MoveTo(Width - 1, DisplayRect.top - 2);
         canvas->LineTo(Width, DisplayRect.top - 2);

         canvas->Pen->Color = Color;
         canvas->Pen->Width = 6;
         canvas->LineTo(Width, Height);
         canvas->LineTo(0, Height);
         canvas->LineTo(0, DisplayRect.top - 1);
         }

      __finally
         {
         delete canvas;
         }
      }
   }

void __fastcall TdjPageControl::SetLookAndFeel(TFpcStyle style)
   {
   if (style == lookAndFeel) return;

   lookAndFeel = style;
   Repaint();
   }


// Component Stuff -----------------------------------------------------------------------------------------------------

namespace Djpagecontrol
{
   void __fastcall PACKAGE Register()
   {
       TComponentClass classes[1] = {__classid(TdjPageControl)};
       RegisterComponents("Developer's Journal", classes, 0);
   }
}

static inline void ValidCtrCheck(TdjPageControl *)
   {
   new TdjPageControl(NULL);
   }
